#pragma once

#include <systypes/base.h>

#include <mutex>

#include "memory_utils.h"
#include "region.h"



/* A memory pool abstraction. */

class Memory
{
protected:
    std::mutex _lock;
    offset_t _region_size;

public:
    explicit Memory(offset_t region_size=PAGE_SIZE);

    virtual Region *allocate(offset_t size);

    virtual Region *region() = 0;

    virtual void release(Region *region) = 0;
};

// vim: tabstop=4 expandtab shiftwidth=4
